unit Interfaces;

interface

uses
  Forms,
  Spring.Collections,
  Data;

type
  TGreeting = type string;
  INavigationService = interface
    ['{38945F0C-A9CF-4F24-B6F2-91419CF6856F}']
    procedure NavigateTo(const moduleName: string);
  end;

  IModuleProvider = interface
    ['{116F2311-E95D-416D-B232-E33CF9A2B9F0}']
    function GetModules: IReadOnlyList<TModule>;
  end;

  IViewProvider = interface
    ['{96D3A219-48C6-40DB-A54C-0B45983A9470}']
    function GetView(const name: string): TFrame;
  end;

  IDialogService = interface
    ['{1CA94C8E-991F-4549-8968-A2308DFED6BD}']
    procedure ShowDialog;
  end;

  {$M+}
  TViewFactory = reference to function(const name: string): TFrame;
  {$M-}

  IMainForm = interface
    ['{2F19E988-F0B3-46E4-9C86-2CEA7349896F}']
    procedure PlaceFrame(const frame: TFrame);
  end;

implementation

end.
