unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Interfaces;

type
  TMainForm = class(TForm, IMainForm)
    procedure FormCreate(Sender: TObject);
  private
    fActiveFrame: TFrame;
  protected
    procedure UsingContainer;
  public
    destructor Destroy; override;
    procedure PlaceFrame(const frame: TFrame);
  end;

var
  MainForm: TMainForm;

implementation

uses
  PureDI,
  Spring.Container,
  Registrations,
  NavigationView;

{$R *.dfm}

destructor TMainForm.Destroy;
begin
  PlaceFrame(nil);
  inherited;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  UsingContainer;
//  BuildStuff;
end;

procedure TMainForm.PlaceFrame(const frame: TFrame);
begin
  if Assigned(fActiveFrame) then
    fActiveFrame.Parent := nil;
  fActiveFrame := frame;
  if Assigned(fActiveFrame) then
  begin
    fActiveFrame.Parent := Self;
    fActiveFrame.Align := alClient;
  end;
end;

procedure TMainForm.UsingContainer;
var
  frame: TFrame;
begin
  RegisterTypes(GlobalContainer);

  frame := GlobalContainer.Resolve<TNavigationFrame>;
  frame.Parent := Self;
  frame.Align := alLeft;
end;

end.
