unit PureDI;

interface

procedure BuildStuff;

implementation

uses
  Main,
  NavigationView,
  ModuleProvider,
  NavigationService,
  ViewProvider,
  Forms,
  CustomersView,
  DialogService,
  Interfaces,
  OrdersView,
  SysUtils,
  Controls;

function ViewFactory(const name: string): TFrame;
begin
  if name = 'Customers_View' then
    Result := TCustomersFrame.Create(TDialogService.Create(''))
//      function: IDialogService
//      begin
//        Result := TDialogService.Create;
//      end)
  else if name = 'Orders_View' then
    Result := TOrdersFrame.Create(nil)
  else
    raise Exception.CreateFmt('could not create view "%s"', [name]);
end;

procedure BuildStuff;
var
  frame: TFrame;
begin
  frame := TNavigationFrame.Create(
    TModuleProvider.Create,
    TNavigationService.Create(
      MainForm,
      TViewProvider.Create(
         ViewFactory
      )
    )
  );

  frame.Parent := MainForm;
  frame.Align := alLeft;
end;

end.
