unit Registrations;

interface

uses
  Spring.Container;

procedure RegisterTypes(const container: TContainer);

implementation

uses
  Main,
  NavigationService,
  ModuleProvider,
  ViewProvider,
  Interfaces,
  NavigationView,
  Spring.Container.Common,
  CustomersView,
  Forms,
  OrdersView,
  DialogService,
  NavigationServiceDecorator;

procedure RegisterTypes(const container: TContainer);
begin
  container.RegisterType<TNavigationService>.Implements<INavigationService>;
  container.RegisterType<TModuleProvider>;
  container.RegisterType<TViewProvider>;
  container.RegisterType<TDialogService>;
  container.RegisterInstance<TGreeting>('hello bergamo');


  container.RegisterType<TNavigationFrame, TNavigationFrame>;
  container.RegisterType<TFrame, TCustomersFrame>('Customers_View');
  container.RegisterType<TFrame, TOrdersFrame>('Orders_View');

  container.RegisterInstance<IMainForm>(MainForm);

//  container.RegisterFactory<TViewFactory>(TParamResolution.ByValue);
  container.RegisterInstance<TViewFactory>(
    function(const name: string): TFrame
    begin
      Result := container.Resolve<TFrame>(name);
    end);

//  container.RegisterDecorator<INavigationService, TNavigationServiceDecorator>;

  container.Build;
end;

end.
