unit NavigationServiceDecorator;

interface

uses
  Interfaces,
  Dialogs;

type
  TNavigationServiceDecorator = class(TInterfacedObject, INavigationService)
  private
    fDecoratee: INavigationService;
  public
    constructor Create(const decoratee: INavigationService);
    procedure NavigateTo(const moduleName: string);
  end;

implementation

uses
  UITypes;

{ TNavigationServiceDecorator }

constructor TNavigationServiceDecorator.Create(
  const decoratee: INavigationService);
begin
  inherited Create;
  fDecoratee := decoratee;
end;

procedure TNavigationServiceDecorator.NavigateTo(const moduleName: string);
begin
  if MessageDlg('You really want to navigate to "' + moduleName + '"?', mtConfirmation, mbYesNo, 0) = mrYes then
    fDecoratee.NavigateTo(moduleName);
end;

end.
