unit ModuleProvider;

interface

uses
  Interfaces,
  Spring.Collections,
  Data;

type
  TModuleProvider = class(TInterfacedObject, IModuleProvider)
  private
    fModules: IList<TModule>;
  public
    constructor Create;
    function GetModules: IReadOnlyList<TModule>;
  end;

implementation

{ TModuleProvider }

constructor TModuleProvider.Create;
begin
  inherited Create;
  fModules := TCollections.CreateObjectList<TModule>();
  fModules.Add(TModule.Create('Customers', 'Customers_View'));
  fModules.Add(TModule.Create('Orders', 'Orders_View'));
end;

function TModuleProvider.GetModules: IReadOnlyList<TModule>;
begin
  Result := fModules.AsReadOnlyList;
end;

end.
