unit NavigationService;

interface

uses
  Interfaces,
  Forms;

type
  TNavigationService = class(TInterfacedObject, INavigationService)
  private
    fMainForm: IMainForm;
    fViewProvider: IViewProvider;
  public
    constructor Create(const mainForm: IMainForm;
      const viewProvider: IViewProvider);
    procedure NavigateTo(const moduleName: string);
  end;

implementation

{ TNavigationService }

constructor TNavigationService.Create(const mainForm: IMainForm;
  const viewProvider: IViewProvider);
begin
  inherited Create;
  fMainForm := mainForm;
  fViewProvider := viewProvider;
end;

procedure TNavigationService.NavigateTo(const moduleName: string);
var
  view: TFrame;
begin
  view := fViewProvider.GetView(moduleName);
  fMainForm.PlaceFrame(view);
end;

end.
