unit ViewProvider;

interface

uses
  Interfaces,
  Spring.Collections,
  Forms;

type
  TViewProvider = class(TInterfacedObject, IViewProvider)
  private
    fViewCache: IDictionary<string,TFrame>;
    fViewFactory: TViewFactory;
  public
    constructor Create(const viewFactory: TViewFactory);
    function GetView(const name: string): TFrame;
  end;

implementation

{ TViewProvider }

constructor TViewProvider.Create(const viewFactory: TViewFactory);
begin
  inherited Create;
  fViewCache := TCollections.CreateDictionary<string, TFrame>([doOwnsValues]);
  fViewFactory := viewFactory;
end;

function TViewProvider.GetView(const name: string): TFrame;
begin
  if not fViewCache.TryGetValue(name, Result) then
  begin
    Result := fViewFactory(name);
    fViewCache[name] := Result;
  end;
end;

end.
