unit NavigationView;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes,
  Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls,
  Interfaces;

type
  TNavigationFrame = class(TFrame)
    ListBox1: TListBox;
    procedure ListBox1DblClick(Sender: TObject);
  private
    fModuleProvider: IModuleProvider;
    fNavigationService: INavigationService;

    procedure InitializeUI;
  public
    constructor Create(
      const moduleProvider: IModuleProvider;
      const navigationService: INavigationService); reintroduce;
  end;

implementation

uses
  Data;

{$R *.dfm}

constructor TNavigationFrame.Create(const moduleProvider: IModuleProvider;
  const navigationService: INavigationService);
begin
  inherited Create(nil);
  fModuleProvider := moduleProvider;
  fNavigationService := navigationService;

  InitializeUI;
end;

procedure TNavigationFrame.InitializeUI;
var
  module: TModule;
begin
  for module in fModuleProvider.GetModules do
    ListBox1.Items.AddObject(module.Caption, module);
end;

procedure TNavigationFrame.ListBox1DblClick(Sender: TObject);
var
  index: Integer;
  moduleName: string;
begin
  index := ListBox1.ItemIndex;
  if index > -1 then
  begin
    moduleName := (ListBox1.Items.Objects[index] as TModule).Name;
    fNavigationService.NavigateTo(moduleName);
  end;
end;

end.
